Index: branches/2015/dev_r5936_INGV1_WAVE/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90
===================================================================
--- branches/2015/dev_r5936_INGV1_WAVE/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 7345)
+++ branches/2015/dev_r5936_INGV1_WAVE/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 7346)
@@ -9,5 +9,4 @@
    !!             -   !  2010-09  (D.Storkey and E.O'Dea) bug fixes for BDY module
    !!            3.3  !  2011-10  (M. Leclair) split former ssh_wzv routine and remove all vvl related work
-   !!            3.6  !  2014-10  (E. Clementi, P. Oddo) add wave contribution to surface vertical velocity 
    !!----------------------------------------------------------------------
 
@@ -39,5 +38,4 @@
    USE wrk_nemo        ! Memory Allocation
    USE timing          ! Timing
-   USE sbcwave         ! Stokes velocities
 
    IMPLICIT NONE
@@ -162,5 +160,4 @@
       REAL(wp), POINTER, DIMENSION(:,:  ) ::  z2d
       REAL(wp), POINTER, DIMENSION(:,:,:) ::  z3d, zhdiv
-      REAL(wp) ::  zdsshu, zdsshv
       !!----------------------------------------------------------------------
       !
@@ -210,18 +207,4 @@
       ENDIF
 
-      IF( ln_wave .AND. ln_sdw ) THEN
-         ! Compute d(ssh)/dx  and d(ssh)/dy  
-         ! Compute the surface vertical velocity accounting for the Stokes Drift
-         DO jj = 1 , jpjm1
-            DO ji = 1 , fs_jpim1
-              zdsshu = ( sshn(ji+1,jj) - sshn(ji,jj) ) / e1u(ji,jj)
-              zdsshv = ( sshn(ji,jj+1) - sshn(ji,jj) ) / e2v(ji,jj)
-              wn(ji,jj,1) = wn(ji,jj,1) + ( usd3dt(ji,jj,1) * zdsshu   &
-                 &                        + vsd3dt(ji,jj,1) * zdsshv   &
-                 &        - wsd3d (ji,jj,1) ) * tmask(ji,jj,1)
-            END DO
-         END DO
-      ENDIF
-      !
 #if defined key_bdy
       IF( lk_bdy ) THEN
Index: branches/2015/dev_r5936_INGV1_WAVE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- branches/2015/dev_r5936_INGV1_WAVE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 7345)
+++ branches/2015/dev_r5936_INGV1_WAVE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 7346)
@@ -377,5 +377,5 @@
             SELECT CASE( nsbc )
             CASE(  0,1,2,3,5,-1 )  ;
-                IF(lwp .AND. kt == nit000 ) WRITE(numout,*) 'WARNING: You are subtracting the wave stress to the ocean. &
+                IF(lwp) WRITE(numout,*) 'WARNING: You are subtracting the wave stress to the ocean. &
                         & If not requested select ln_tauoc=.false'
             END SELECT
Index: branches/2015/dev_r5936_INGV1_WAVE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90
===================================================================
--- branches/2015/dev_r5936_INGV1_WAVE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90	(revision 7345)
+++ branches/2015/dev_r5936_INGV1_WAVE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90	(revision 7346)
@@ -7,5 +7,4 @@
    !!         :  3.4  !   2012-10  (M. Adani)  Stokes Drift 
    !!            3.6  !   2014-09  (E. Clementi,P. Oddo) New Stokes Drift Computation
-   !!            3.6  !   2014-09  (Clementi E, Oddo P)New Stokes Drift Computation
    !!----------------------------------------------------------------------
 
@@ -54,5 +53,4 @@
    REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:)       :: tauoc_wave
    REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:)       :: tsd2d
-   REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:)       :: usd2d, vsd2d
    REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:)       :: zusd2dt, zvsd2dt
    REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:,:)     :: usd3d, vsd3d, wsd3d 
@@ -281,5 +279,4 @@
                CALL fld_fill( sf_sd, slf_i, cn_dir, 'sbc_wave', 'Wave module ', 'namsbc_wave' )
             ENDIF
-            ALLOCATE( usd2d(jpi,jpj),vsd2d(jpi,jpj) )
             ALLOCATE( usd3d(jpi,jpj,jpk),vsd3d(jpi,jpj,jpk),wsd3d(jpi,jpj,jpk) )
             ALLOCATE( usd3dt(jpi,jpj,jpk),vsd3dt(jpi,jpj,jpk) )
Index: branches/2015/dev_r5936_INGV1_WAVE/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- branches/2015/dev_r5936_INGV1_WAVE/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 7345)
+++ branches/2015/dev_r5936_INGV1_WAVE/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 7346)
@@ -220,9 +220,7 @@
                          CALL dyn_adv       ( kstp )  ! advection (vector or flux form)
                          CALL dyn_vor       ( kstp )  ! vorticity term including Coriolis
-      IF( ln_wave .AND. ln_sdw .AND. ln_stcor    )  &
+      IF( ln_wave .AND. ln_sdw .AND. ln_stcor)           &
                &         CALL dyn_stcor     ( kstp )  ! Stokes-Coriolis forcing
                          CALL dyn_ldf       ( kstp )  ! lateral mixing
-      IF( ln_wave .AND. ln_sdw .AND. ln_stcor)           & 
-               &         CALL dyn_stcor     ( kstp )  ! Stokes-Coriolis forcing
                          CALL dyn_hpg       ( kstp )  ! horizontal gradient of Hydrostatic pressure
                          CALL dyn_spg       ( kstp )  ! surface pressure gradient