Index: branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 7354)
+++ branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 7359)
@@ -412,4 +412,5 @@
          srcv(jpr_itx1)%clgrid = 'U'                  ! ocean stress used after its transformation
          srcv(jpr_ity1)%clgrid = 'V'                  ! i.e. it is always at U- & V-points for i- & j-comp. resp.
+      ENDIF
       ENDIF
 
Index: branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90
===================================================================
--- branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90	(revision 7354)
+++ branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90	(revision 7359)
@@ -96,5 +96,5 @@
                zk = ABS(zsp0)/MAX(ABS(5.97_wp*ztransp),0.0000001_wp)
                ! Depth attenuation
-               zfac = EXP(-2.0_wp*zk*fsdept(ji,jj,jk))/(1.0_wp+8.0_wp*zk*fsdept(ji,jj,jk))
+               zfac = EXP(-2.0_wp*zk*gdept_n(ji,jj,jk))/(1.0_wp+8.0_wp*zk*gdept_n(ji,jj,jk))
                !
                usd3dt(ji,jj,jk) = zfac * zusd2dt(ji,jj) * tmask(ji,jj,jk)
@@ -139,5 +139,5 @@
       !
       DO jk = jpkm1, 1, -1                   ! integrate from the bottom the e3t * hor. divergence
-         wsd3d(:,:,jk) = wsd3d(:,:,jk+1) - fse3t_n(:,:,jk) * ze3hdiv(:,:,jk)
+         wsd3d(:,:,jk) = wsd3d(:,:,jk+1) - e3t_n(:,:,jk) * ze3hdiv(:,:,jk)
       END DO
 #if defined key_bdy
Index: branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/TRA/traadv.F90
===================================================================
--- branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/TRA/traadv.F90	(revision 7354)
+++ branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/TRA/traadv.F90	(revision 7359)
@@ -108,7 +108,7 @@
       IF( ln_wave .AND. ln_sdw )  THEN
          DO jk = 1, jpkm1
-            zun(:,:,jk) = e2u(:,:) * fse3u(:,:,jk) *      &
+            zun(:,:,jk) = e2u(:,:) * e3u_n(:,:,jk) *      &
                         &  ( un(:,:,jk) + usd3d(:,:,jk) )                       ! eulerian transport + Stokes Drift
-            zvn(:,:,jk) = e1v(:,:) * fse3v(:,:,jk) *      &
+            zvn(:,:,jk) = e1v(:,:) * e3v_n(:,:,jk) *      &
                         &  ( vn(:,:,jk) + vsd3d(:,:,jk) )
             zwn(:,:,jk) = e1e2t(:,:) *                    &
@@ -117,6 +117,6 @@
       ELSE
          DO jk = 1, jpkm1
-            zun(:,:,jk) = e2u  (:,:) * fse3u(:,:,jk) * un(:,:,jk)               ! eulerian transport only
-            zvn(:,:,jk) = e1v  (:,:) * fse3v(:,:,jk) * vn(:,:,jk)
+            zun(:,:,jk) = e2u  (:,:) * e3u_n(:,:,jk) * un(:,:,jk)               ! eulerian transport only
+            zvn(:,:,jk) = e1v  (:,:) * e3v_n(:,:,jk) * vn(:,:,jk)
             zwn(:,:,jk) = e1e2t(:,:)                 * wn(:,:,jk)
          END DO
Index: branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfqiao.F90
===================================================================
--- branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfqiao.F90	(revision 7354)
+++ branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfqiao.F90	(revision 7359)
@@ -70,8 +70,8 @@
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1
-               qbv(ji,jj,jk) = 1.0 * 0.353553 * swh(ji,jj) * tsd2d(ji,jj) *           &
-            &                  EXP(3.0 * wnum(ji,jj) *                                &                     
-            &                  (-MIN( fsdepw(ji  ,jj  ,jk), fsdepw(ji+1,jj  ,jk),     &
-            &                         fsdepw(ji  ,jj+1,jk), fsdepw(ji+1,jj+1,jk))))   &
+               qbv(ji,jj,jk) = 1.0 * 0.353553 * swh(ji,jj) * tsd2d(ji,jj) *             &
+            &                  EXP(3.0 * wnum(ji,jj) *                                  &                     
+            &                  (-MIN( gdepw_n(ji  ,jj  ,jk), gdepw_n(ji+1,jj  ,jk),     &
+            &                         gdepw_n(ji  ,jj+1,jk), gdepw_n(ji+1,jj+1,jk))))   &
             &                          * wmask(ji,jj,jk)
             END DO
Index: branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90
===================================================================
--- branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 7354)
+++ branches/2016/dev_INGV_UKMO_2016/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 7359)
@@ -205,5 +205,5 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1
-               IF( fsdept(ji,jj,jk) < ekm_dep(ji,jj) ) THEN
+               IF( gdepw_n(ji,jj,jk) < ekm_dep(ji,jj) ) THEN
                   avmv(ji,jj,jk) = MAX( avmv(ji,jj,jk), rn_wvmix )
                   avmu(ji,jj,jk) = MAX( avmu(ji,jj,jk), rn_wvmix )