Index: branches/2016/dev_CNRS_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90
===================================================================
--- branches/2016/dev_CNRS_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 7357)
+++ branches/2016/dev_CNRS_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 7366)
@@ -115,5 +115,5 @@
       !!----------------------------------------------------------------------
 
-      IF( nn_timing == 1 )  CALL timing_start('sbc_ice_lim')
+      IF( nn_timing == 1 )   CALL timing_start('sbc_ice_lim')
 
       ! clem: it is important to initialize agrif_lim3 variables here and not in sbc_lim_init
@@ -152,8 +152,9 @@
          ! utau_ice, vtau_ice : surface ice stress (U- & V-points)   [N/m2]
          !-----------------------------------------------------------------
+                                      CALL sbc_lim_bef         ! Store previous ice values
          SELECT CASE( ksbc )
-            CASE( jp_usr     )   ;   CALL usrdef_sbc_ice_tau( kt )                 ! user defined formulation
-            CASE( jp_blk     )   ;   CALL blk_ice_tau                              ! Bulk formulation
-            CASE( jp_purecpl )   ;   CALL sbc_cpl_ice_tau( utau_ice , vtau_ice )   ! Coupled   formulation
+            CASE( jp_usr     )   ;    CALL usrdef_sbc_ice_tau( kt )                 ! user defined formulation
+            CASE( jp_blk     )   ;    CALL blk_ice_tau                              ! Bulk formulation
+            CASE( jp_purecpl )   ;    CALL sbc_cpl_ice_tau( utau_ice , vtau_ice )   ! Coupled   formulation
          END SELECT
 
@@ -171,5 +172,4 @@
          numit = numit + nn_fsbc                  ! Ice model time step
          !
-                                      CALL sbc_lim_bef         ! Store previous ice values
                                       CALL sbc_lim_diag0       ! set diag of mass, heat and salt fluxes to 0
                                       CALL lim_rst_opn( kt )   ! Open Ice restart file
@@ -220,16 +220,16 @@
                                       CALL albedo_ice( t_su, ht_i, ht_s, zalb_cs, zalb_os ) ! cloud-sky and overcast-sky ice albedos
          SELECT CASE( ksbc )
-            CASE( jp_usr )   ;      CALL usrdef_sbc_ice_flx( kt ) ! user defined formulation
-            CASE( jp_blk )                                       ! bulk formulation
+            CASE( jp_usr )   ;        CALL usrdef_sbc_ice_flx( kt ) ! user defined formulation
+            CASE( jp_blk )                                          ! bulk formulation
                ! albedo depends on cloud fraction because of non-linear spectral effects
                alb_ice(:,:,:) = ( 1. - cldf_ice ) * zalb_cs(:,:,:) + cldf_ice * zalb_os(:,:,:)
-                                    CALL blk_ice_flx( t_su, alb_ice )
-               IF( ln_mixcpl      ) CALL sbc_cpl_ice_flx( p_frld=pfrld, palbi=alb_ice, psst=sst_m, pist=t_su )
-               IF( nn_limflx /= 2 ) CALL ice_lim_flx( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
+                                      CALL blk_ice_flx( t_su, alb_ice )
+               IF( ln_mixcpl      )   CALL sbc_cpl_ice_flx( p_frld=pfrld, palbi=alb_ice, psst=sst_m, pist=t_su )
+               IF( nn_limflx /= 2 )   CALL ice_lim_flx( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
             CASE ( jp_purecpl )
                ! albedo depends on cloud fraction because of non-linear spectral effects
                alb_ice(:,:,:) = ( 1. - cldf_ice ) * zalb_cs(:,:,:) + cldf_ice * zalb_os(:,:,:)
-                                    CALL sbc_cpl_ice_flx( p_frld=pfrld, palbi=alb_ice, psst=sst_m, pist=t_su )
-               IF( nn_limflx == 2 ) CALL ice_lim_flx( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
+                                      CALL sbc_cpl_ice_flx( p_frld=pfrld, palbi=alb_ice, psst=sst_m, pist=t_su )
+               IF( nn_limflx == 2 )   CALL ice_lim_flx( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
          END SELECT
 